? sys-file-reader.patch
Index: Smake
===================================================================
RCS file: /cvsroot/pspp/pspp/Smake,v
retrieving revision 1.40
diff -u -p -r1.40 Smake
--- Smake	3 Nov 2006 04:53:51 -0000	1.40
+++ Smake	10 Dec 2006 22:31:55 -0000
@@ -20,6 +20,7 @@ GNULIB_MODULES = \
 	getopt \
 	gettext \
 	intprops \
+	inttostr \
 	linebreak \
 	localcharset \
 	memcasecmp \
@@ -48,6 +49,7 @@ GNULIB_MODULES = \
 	strtol \
 	strtoul \
 	unistd \
+	unlocked-io \
 	vsnprintf \
 	xalloc \
 	xalloc-die \
Index: src/data/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/ChangeLog,v
retrieving revision 1.86
diff -u -p -r1.86 ChangeLog
--- src/data/ChangeLog	10 Dec 2006 04:08:47 -0000	1.86
+++ src/data/ChangeLog	10 Dec 2006 22:31:56 -0000
@@ -1,3 +1,27 @@
+Sun Dec 10 14:21:29 2006  Ben Pfaff  <blp@gnu.org>
+
+	* sfm-private.h: Move contents into sys-file-writer.c, which is
+	the only remaining user.  Removed Borland C++-specific directives.
+	
+	* sys-file-reader.c: Clean up and rewrite entire file.  The
+	rewritten version is simpler and better abstracted, and should be
+	easier to maintain and extend.  It avoids using structures to read
+	file data, which is prone to padding variations among compilers.
+	It should also handle non-IEEE 754 system files, although I
+	haven't been able to find any.  It has been tested against many
+	.sav files obtained from the Web and found to produce the same
+	results as the earlier version of the code, or in some cases
+	improved results.  It is more tolerant of format variations found
+	in the wild.
+
+	* sys-file-reader.h (struct sfm_read_info): Removed `big_endian'
+	member, putting an enum integer_format in its place.  New member
+	`float_format'.  Changed `compressed' member to type bool.
+
+Sun Dec 10 13:48:53 2006  Ben Pfaff  <blp@gnu.org>
+
+	* dictionary.c (dict_delete_consecutive_vars): New function.
+
 Sat Dec  9 20:08:25 2006  Ben Pfaff  <blp@gnu.org>
 
 	* file-name.c (fn_search_path): Remove prefix arg that was unused
Index: src/data/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/automake.mk,v
retrieving revision 1.10
diff -u -p -r1.10 automake.mk
--- src/data/automake.mk	10 Dec 2006 03:42:50 -0000	1.10
+++ src/data/automake.mk	10 Dec 2006 22:31:56 -0000
@@ -57,7 +57,6 @@ src_data_libdata_a_SOURCES = \
 	src/data/scratch-writer.h \
 	src/data/settings.c \
 	src/data/settings.h \
-	src/data/sfm-private.h \
 	src/data/storage-stream.c \
 	src/data/storage-stream.h \
 	src/data/sys-file-private.c \
Index: src/data/dictionary.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/dictionary.c,v
retrieving revision 1.21
diff -u -p -r1.21 dictionary.c
--- src/data/dictionary.c	10 Dec 2006 03:42:50 -0000	1.21
+++ src/data/dictionary.c	10 Dec 2006 22:31:56 -0000
@@ -463,6 +463,20 @@ dict_delete_vars (struct dictionary *d,
     dict_delete_var (d, *vars++);
 }
 
+/* Deletes the COUNT variables in D starting at index IDX.  This
+   is unsafe; see the comment on dict_delete_var() for
+   details. */
+void
+dict_delete_consecutive_vars (struct dictionary *d, size_t idx, size_t count) 
+{
+  /* FIXME: this can be done in O(count) time, but this algorithm
+     is O(count**2). */
+  assert (idx + count <= d->var_cnt);
+  
+  while (count-- > 0)
+    dict_delete_var (d, d->var[idx]);
+}
+
 /* Deletes scratch variables from dictionary D. */
 void
 dict_delete_scratch_vars (struct dictionary *d)
Index: src/data/dictionary.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/dictionary.h,v
retrieving revision 1.5
diff -u -p -r1.5 dictionary.h
--- src/data/dictionary.h	10 Dec 2006 03:42:50 -0000	1.5
+++ src/data/dictionary.h	10 Dec 2006 22:31:57 -0000
@@ -55,6 +55,8 @@ bool dict_contains_var (const struct dic
 void dict_delete_var (struct dictionary *, struct variable *);
 void dict_delete_vars (struct dictionary *,
                        struct variable *const *, size_t count);
+void dict_delete_consecutive_vars (struct dictionary *d,
+                                   size_t idx, size_t count);
 void dict_delete_scratch_vars (struct dictionary *);
 void dict_reorder_var (struct dictionary *d, struct variable *v,
                        size_t new_index);
Index: src/data/sys-file-reader.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/sys-file-reader.c,v
retrieving revision 1.28
diff -u -p -r1.28 sys-file-reader.c
--- src/data/sys-file-reader.c	10 Dec 2006 03:42:50 -0000	1.28
+++ src/data/sys-file-reader.c	10 Dec 2006 22:31:58 -0000
@@ -20,14 +20,13 @@
 #include <config.h>
 
 #include "sys-file-reader.h"
-#include "sfm-private.h"
 #include "sys-file-private.h"
 
-#include <stdlib.h>
 #include <errno.h>
 #include <float.h>
-#include <c-ctype.h>
-#include <minmax.h>
+#include <inttypes.h>
+#include <setjmp.h>
+#include <stdlib.h>
 
 #include <libpspp/alloc.h>
 #include <libpspp/assertion.h>
@@ -35,6 +34,7 @@
 #include <libpspp/compiler.h>
 #include <libpspp/magic.h>
 #include <libpspp/misc.h>
+#include <libpspp/pool.h>
 #include <libpspp/str.h>
 #include <libpspp/hash.h>
 #include <libpspp/array.h>
@@ -46,232 +46,123 @@
 #include "format.h"
 #include "missing-values.h"
 #include "value-labels.h"
-#include "value.h"
 #include "variable.h"
+#include "value.h"
+
+#include "c-ctype.h"
+#include "inttostr.h"
+#include "minmax.h"
+#include "unlocked-io.h"
+#include "xsize.h"
 
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
+#define N_(msgid) (msgid)
 
 /* System file reader. */
 struct sfm_reader
-{
-  struct file_handle *fh;     /* File handle. */
-  FILE *file;			/* File stream. */
-
-  int reverse_endian;		/* 1=file has endianness opposite us. */
-  int value_cnt;		/* Number of `union values's per case. */
-  long case_cnt;		/* Number of cases, -1 if unknown. */
-  int compressed;		/* 1=compressed, 0=not compressed. */
-  double bias;		        /* Compression bias, usually 100.0. */
-  int weight_idx;		/* 0-based index of weighting variable, or -1. */
-  bool ok;                    /* False after an I/O error or corrupt data. */
-  bool has_vls;         /* True if the file has one or more Very Long Strings*/
-
-  /* Variables. */
-  struct sfm_var *vars;
-  size_t var_cnt;
-
-  /* File's special constants. */
-  flt64 sysmis;
-  flt64 highest;
-  flt64 lowest;
-
-  /* Decompression buffer. */
-  flt64 *buf;			/* Buffer data. */
-  flt64 *ptr;			/* Current location in buffer. */
-  flt64 *end;			/* End of buffer data. */
-
-  /* Compression instruction octet. */
-  unsigned char x[8];         /* Current instruction octet. */
-  unsigned char *y;		/* Location in current instruction octet. */
-};
+  {
+    /* Resource tracking. */
+    struct pool *pool;          /* All system file state. */
+    jmp_buf bail_out;           /* longjmp() target for error handling. */
+
+    /* File state. */
+    struct file_handle *fh;     /* File handle. */
+    FILE *file;                 /* File stream. */
+    bool error;                 /* I/O or corruption error? */
+
+    /* File format. */
+    enum integer_format integer_format; /* On-disk integer format. */
+    enum float_format float_format; /* On-disk floating point format. */
+    int value_cnt;		/* Number of 8-byte units per case. */
+    struct sfm_var *vars;       /* Variables. */
+    size_t var_cnt;             /* Number of variables. */
+    bool has_vls;               /* File has one or more very long strings? */
+
+    /* Decompression. */
+    bool compressed;		/* File is compressed? */
+    double bias;		/* Compression bias, usually 100.0. */
+    uint8_t opcodes[8];         /* Current block of opcodes. */
+    size_t opcode_idx;          /* Next opcode to interpret, 8 if none left. */
+  };
 
 /* A variable in a system file. */
 struct sfm_var 
-{
-  int width;                  /* 0=numeric, otherwise string width. */
-  int fv;                     /* Index into case. */
-};
-
-/* Utilities. */
-
-/* Swap bytes *A and *B. */
-static inline void
-bswap (char *a, char *b) 
-{
-  char t = *a;
-  *a = *b;
-  *b = t;
-}
-
-/* Reverse the byte order of 32-bit integer *X. */
-static inline void
-bswap_int32 (int32_t *x_)
-{
-  char *x = (char *) x_;
-  bswap (x + 0, x + 3);
-  bswap (x + 1, x + 2);
-}
+  {
+    int width;                  /* 0=numeric, otherwise string width. */
+    int case_index;             /* Index into case. */
+  };
 
-/* Reverse the byte order of 64-bit floating point *X. */
-static inline void
-bswap_flt64 (flt64 *x_)
-{
-  char *x = (char *) x_;
-  bswap (x + 0, x + 7);
-  bswap (x + 1, x + 6);
-  bswap (x + 2, x + 5);
-  bswap (x + 3, x + 4);
-}
+static struct variable **make_var_by_value_idx (struct sfm_reader *,
+                                                struct dictionary *);
+static struct variable *lookup_var_by_value_idx (struct sfm_reader *,
+                                                 struct variable **,
+                                                 int value_idx);
 
-static void
-corrupt_msg (int class, const char *format,...)
+static void sys_warn (struct sfm_reader *, const char *, ...)
      PRINTF_FORMAT (2, 3);
 
-     /* Displays a corrupt sysfile error. */
-     static void
-     corrupt_msg (int class, const char *format,...)
-{
-  struct msg m;
-  va_list args;
-  struct string text;
-
-  ds_init_cstr (&text, _("corrupt system file: "));
-  va_start (args, format);
-  ds_put_vformat (&text, format, args);
-  va_end (args);
-
-  m.category = msg_class_to_category (class);
-  m.severity = msg_class_to_severity (class);
-  m.where.file_name = NULL;
-  m.where.line_number = 0;
-  m.text = ds_cstr (&text);
-
-  msg_emit (&m);
-}
-
-/* Closes a system file after we're done with it. */
-void
-sfm_close_reader (struct sfm_reader *r)
-{
-  if (r == NULL)
-    return;
-
-  if (r->file)
-    {
-      if (fn_close (fh_get_file_name (r->fh), r->file) == EOF)
-        msg (ME, _("%s: Closing system file: %s."),
-             fh_get_file_name (r->fh), strerror (errno));
-      r->file = NULL;
-    }
-
-  if (r->fh != NULL)
-    fh_close (r->fh, "system file", "rs");
-
-  free (r->vars);
-  free (r->buf);
-  free (r);
-}
+static void sys_error (struct sfm_reader *, const char *, ...)
+     PRINTF_FORMAT (2, 3)
+     NO_RETURN;
+
+static void read_bytes (struct sfm_reader *, void *, size_t);
+static bool try_read_bytes (struct sfm_reader *, void *, size_t);
+static int32_t read_int32 (struct sfm_reader *);
+static double read_flt64 (struct sfm_reader *);
+static void read_string (struct sfm_reader *, char *, size_t);
+static void skip_bytes (struct sfm_reader *, size_t);
+
+static int32_t int32_to_native (const struct sfm_reader *, const uint8_t[4]);
+static double flt64_to_double (const struct sfm_reader *, const uint8_t[8]);
+
+static struct variable_to_value_map *open_variable_to_value_map (
+  struct sfm_reader *, size_t size);
+static void close_variable_to_value_map (struct sfm_reader *r,
+                                         struct variable_to_value_map *);
+static bool read_variable_to_value_map (struct sfm_reader *,
+                                        struct dictionary *,
+                                        struct variable_to_value_map *,
+                                        struct variable **var, char **value,
+                                        int *warning_cnt);
 
 /* Dictionary reader. */
 
-static void buf_unread(struct sfm_reader *r, size_t byte_cnt);
-
-static void *buf_read (struct sfm_reader *, void *buf, size_t byte_cnt,
-                       size_t min_alloc);
-
-static int read_header (struct sfm_reader *,
-                        struct dictionary *, struct sfm_read_info *);
-static int parse_format_spec (struct sfm_reader *, int32_t,
-			      struct fmt_spec *, const struct variable *);
-static int read_value_labels (struct sfm_reader *, struct dictionary *,
-                              struct variable **var_by_idx);
-static int read_variables (struct sfm_reader *,
-                           struct dictionary *, struct variable ***var_by_idx);
-static int read_machine_int32_info (struct sfm_reader *, int size, int count);
-static int read_machine_flt64_info (struct sfm_reader *, int size, int count);
-static int read_documents (struct sfm_reader *, struct dictionary *);
-
-static int fread_ok (struct sfm_reader *, void *, size_t);
-
-/* Displays the message X with corrupt_msg, then jumps to the error
-   label. */
-#define lose(X)                                 \
-	do {                                    \
-	    corrupt_msg X;                      \
-	    goto error;                         \
-	} while (0)
-
-/* Calls buf_read with the specified arguments, and jumps to
-   error if the read fails. */
-#define assertive_buf_read(a,b,c,d)             \
-	do {                                    \
-	    if (!buf_read (a,b,c,d))            \
-	      goto error;                       \
-	} while (0)
-
-
-struct name_pair
-{
-  char *shortname;
-  char *longname;
-};
-
-static int
-pair_sn_compare(const void *_p1, const void *_p2, const void *aux UNUSED)
-{
-  int i;
-
-  const struct name_pair *p1 = _p1;
-  const struct name_pair *p2 = _p2;
-
-  char buf1[SHORT_NAME_LEN + 1];
-  char buf2[SHORT_NAME_LEN + 1];
-
-  memset(buf1, 0, SHORT_NAME_LEN + 1);
-  memset(buf2, 0, SHORT_NAME_LEN + 1);
-
-  for (i = 0 ; i <= SHORT_NAME_LEN ; ++i ) 
-    {
-      buf1[i] = p1->shortname[i];
-      if ( '\0' == buf1[i]) 
-	break;
-    }
-
-  for (i = 0 ; i <= SHORT_NAME_LEN ; ++i ) 
-    {
-      buf2[i] = p2->shortname[i];
-      if ( '\0' == buf2[i]) 
-	break;
-    }
-
-  return strncmp(buf1, buf2, SHORT_NAME_LEN);
-}
-
-static unsigned int
-pair_sn_hash(const void *_p, const void *aux UNUSED)
-{
-  int i;
-  const struct name_pair *p = _p;
-  char buf[SHORT_NAME_LEN + 1];
-
-  memset(buf, 0, SHORT_NAME_LEN + 1); 
-  for (i = 0 ; i <= SHORT_NAME_LEN ; ++i ) 
-    {
-      buf[i] = p->shortname[i];
-      if ( '\0' == buf[i]) 
-	break;
-    }
-
-  return hsh_hash_bytes(buf, strlen(buf));
-}
-
-static void
-pair_sn_free(void *p, const void *aux UNUSED)
-{
-  free(p);
-}
+enum which_format 
+  {
+    PRINT_FORMAT,
+    WRITE_FORMAT
+  };
 
+static void read_header (struct sfm_reader *, struct dictionary *,
+                         int *weight_idx, int *claimed_value_cnt,
+                         struct sfm_read_info *);
+static void read_variable_record (struct sfm_reader *, struct dictionary *,
+                                  int *format_warning_cnt);
+static void parse_format_spec (struct sfm_reader *, uint32_t,
+                               enum which_format, struct variable *,
+                               int *format_warning_cnt);
+static void setup_weight (struct sfm_reader *, int weight_idx,
+                          struct variable **var_by_value_idx,
+                          struct dictionary *);
+static void read_documents (struct sfm_reader *, struct dictionary *);
+static void read_value_labels (struct sfm_reader *, struct dictionary *,
+                               struct variable **var_by_value_idx);
+
+static void read_extension_record (struct sfm_reader *, struct dictionary *);
+static void read_machine_int32_info (struct sfm_reader *,
+                                     size_t size, size_t count);
+static void read_machine_flt64_info (struct sfm_reader *,
+                                     size_t size, size_t count);
+static void read_display_parameters (struct sfm_reader *,
+                                     size_t size, size_t count,
+                                     struct dictionary *);
+static void read_long_var_name_map (struct sfm_reader *,
+                                    size_t size, size_t count,
+                                    struct dictionary *);
+static void read_long_string_map (struct sfm_reader *,
+                                  size_t size, size_t count,
+                                  struct dictionary *);
 
 
 /* Opens the system file designated by file handle FH for
